diff -Naur nrpe-2.5/src/nrpe.c nrpe-2.5.reiserfs/src/nrpe.c
--- nrpe-2.5/src/nrpe.c	2006-04-06 21:30:00.207859567 +0200
+++ nrpe-2.5.reiserfs/src/nrpe.c	2006-04-06 22:00:26.379158709 +0200
@@ -510,6 +510,7 @@
 	char config_file[MAX_FILENAME_LENGTH];
 	DIR *dirp;
 	struct dirent *dirfile;
+	struct stat buf;
 	int result=OK;
 	int x;
 
@@ -523,19 +524,18 @@
 	/* process all files in the directory... */
 	while((dirfile=readdir(dirp))!=NULL){
 
+		/* create the full path to the config file or subdirectory */
+		snprintf(config_file,sizeof(config_file)-1,"%s/%s",dirname,dirfile->d_name);
+		config_file[sizeof(config_file)-1]='\x0';
+		stat(config_file, &buf);
+
 		/* process this if it's a config file... */
 		x=strlen(dirfile->d_name);
 		if(x>4 && !strcmp(dirfile->d_name+(x-4),".cfg")){
 
-#ifdef _DIRENT_HAVE_D_TYPE
 			/* only process normal files */
-			if(dirfile->d_type!=DT_REG)
+			if (! S_ISREG(buf.st_mode))
 				continue;
-#endif
-
-			/* create the full path to the config file */
-			snprintf(config_file,sizeof(config_file)-1,"%s/%s",dirname,dirfile->d_name);
-			config_file[sizeof(config_file)-1]='\x0';
 
 			/* process the config file */
 			result=read_config_file(config_file);
@@ -545,18 +545,13 @@
 				break;
 		        }
 
-#ifdef _DIRENT_HAVE_D_TYPE
 		/* recurse into subdirectories... */
-		if(dirfile->d_type==DT_DIR){
+		if(S_ISDIR(buf.st_mode)) {
 
 			/* ignore current, parent and hidden directory entries */
 			if(dirfile->d_name[0]=='.')
 				continue;
 
-			/* create the full path to the config directory */
-			snprintf(config_file,sizeof(config_file)-1,"%s/%s",dirname,dirfile->d_name);
-			config_file[sizeof(config_file)-1]='\x0';
-
 			/* process the config directory */
 			result=read_config_dir(config_file);
 
@@ -564,7 +559,6 @@
 			if(result==ERROR)
 				break;
 		        }
-#endif
 		}
 
 	closedir(dirp);
